# spritebatch

### Introduction

SpriteBatch allows games to render 2D graphics to screen. Unlike FlatRedBall's Sprite class, SpriteBatch performs *immediate rendering* - drawing with SpriteBatch results in graphics appearing for only one frame. To keep SpriteBatch graphics on screen for an extended amount of time, Draw must be called every frame. By contrast, FlatRedBall Sprites can be created one time and they will continue to appear on screen until removed from the engine. Three calls are required to render graphics using SpriteBatch:

1. SpriteBatch.Begin - sets initial values to be used for all Draw calls until End is called
2. SpriteBatch.Draw - draws a single sprite to the screen. Draw can be called multiple times between Begin and End, and performing multiple Draw calls between a Begin and End call can improve performance when compared to repeatedly calling Begin and End.
3. SpriteBatch.End - ends the drawing and presents the visuals on-screen or on the current RenderTarget2D.

### Code Example

The SpriteBatch.Draw method is used to render a Texture2D to screen. The Texture2D used can come from anywhere, including Texture2D instances loaded through Glue. The following code shows how to draw an image on screen. FINISH HERE after Entities support IDrawableBatch


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.flatredball.com/flatredball/api/microsoft-xna-framework/graphics/spritebatch.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
